import 'package:better_player/better_player.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:nui_core/nui_core.dart';
import 'package:nui_media/model/nui_media_file.dart';
import 'package:nui_media/nui_media.dart';
import 'package:nui_media/nui_media_util.dart';

class NUIVideoListViewPlayer extends StatefulWidget {
  NUIVideoListViewPlayer({@required this.mediaFile, this.configuration, this.boxFit: BoxFit.fitWidth, this.mute: true, this.autoPlay:true, this.playFraction:0.8, this.showButtons:false, this.aspectRatio, this.loop: true, this.loader, this.width, this.height});
  final NUIMediaFile mediaFile;
  final BetterPlayerConfiguration configuration;
  final bool autoPlay;
  final double playFraction;
  final bool showButtons;
  final double aspectRatio;
  final double width;
  final double height;
  final Widget loader;
  final bool loop;
  final bool mute;
  final BoxFit boxFit;
  @override
  _NUIVideoListViewPlayerState createState() => _NUIVideoListViewPlayerState();
}

class _NUIVideoListViewPlayerState extends NUIVideoPlayerState<NUIVideoListViewPlayer> {
  BetterPlayerDataSource dataSource;
  BetterPlayerListVideoPlayerController _controller;

  @override
  void initState(){
    super.initState();
    _controller = BetterPlayerListVideoPlayerController();
    _controller.setVolume(widget.mute == true ? 0.0 : 1.0);
    dataSource = NUIMediaUtil.dataSourceFromNUIMedia(widget.mediaFile);
  }

  @override
  Widget build(BuildContext context) {
    return adjustSize(mediaFile: widget.mediaFile, adjustSize: widget.aspectRatio == null, width: widget.width, height: widget.height);
  }

  @override
  Widget getVideoPlayer() {
    final placeHolder = widget.loader ?? Center(child: SizedBox(height: 30.0, width: 30.0, child: CircularProgressIndicator(strokeWidth: 1.5, valueColor: new AlwaysStoppedAnimation<Color>(NUIColors.NUIDarkGrayOutline), backgroundColor: NUIColors.NUISkeletalGray)));
    final configuration = widget.configuration ?? BetterPlayerConfiguration(fit: widget.boxFit ?? BoxFit.fitWidth, placeholder: placeHolder, showControlsOnInitialize: widget.showButtons, aspectRatio: widget.aspectRatio, autoPlay: widget.autoPlay, looping: widget.loop, controlsConfiguration: BetterPlayerControlsConfiguration(showControls: widget.showButtons),);
    return BetterPlayerListVideoPlayer(dataSource, betterPlayerListVideoPlayerController: _controller, configuration: configuration, playFraction: widget.playFraction, autoPlay: widget.autoPlay, autoPause: widget.autoPlay);
  }
}
